#COMPILE EXE
#DIM ALL
#UNIQUE VAR ON
#DEBUG DISPLAY ON
#DEBUG ERROR ON

%USEMACROS = 1

$INCLUDE "Win32api.inc"
$INCLUDE "CommCtrl.inc"

%IDD_DIALOG1                        =  101
%IDC_LABEL1                         = 1002
%IDC_COMBOBOX_REGISTERED_FILE_TYPES = 1003

GLOBAL hImagelist AS LONG

#INCLUDE ".\PB_Reg.bas"
#INCLUDE ".\Registry.bi"

'-----------------------------------------------------------------------------------------

FUNCTION PBMAIN()
	LOCAL lRslt AS LONG
	LOCAL hDlg  AS DWORD

	DIALOG NEW 0, "Dialog1", 342, 164, 243, 86, %WS_POPUP OR %WS_BORDER _
		OR %WS_DLGFRAME OR %WS_CAPTION OR %WS_SYSMENU OR %WS_CLIPSIBLINGS OR _
		%WS_VISIBLE OR %DS_MODALFRAME OR %DS_3DLOOK OR %DS_NOFAILCREATE OR _
		%DS_SETFONT, %WS_EX_CONTROLPARENT OR %WS_EX_LEFT OR %WS_EX_LTRREADING OR _
		%WS_EX_RIGHTSCROLLBAR, TO hDlg
	CONTROL ADD BUTTON, hDlg, %IDCLOSE, "Close", 185, 10, 50, 15
	CONTROL ADD LABEL,  hDlg, %IDC_LABEL1, "Windows Registered Filetypes", 10, _
		20, 100, 10
	CONTROL ADD "ComboBoxEx32", hDlg, %IDC_COMBOBOX_REGISTERED_FILE_TYPES, "", 10, 30, 150, 100, _
	 %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS  OR %CBS_DROPDOWNLIST OR  _
	 %WS_VSCROLL OR %WS_HSCROLL OR %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, %WS_EX_LEFT OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR

	DIALOG SHOW MODAL hDlg, CALL ShowDIALOG1Proc TO lRslt

	FUNCTION = lRslt

END FUNCTION

'------------------------------------------------------------------------------

CALLBACK FUNCTION ShowDIALOG1Proc()

	SELECT CASE AS LONG CB.MSG
		CASE %WM_INITDIALOG ' Initialization handler
			$DEBUG CODE ON
			EnumRegKeyFileTypes()         ' find each file extension in registry
			GetAssocAppInfoFileTypes()    ' get name of associated app info key from each extension key
			GetDescStringsFileTypes()     ' use the associated app info key to get the plain english description of the associated application
			GetIconsFileTypes(CB.HNDL,%IDC_COMBOBOX_REGISTERED_FILE_TYPES)
		CASE %WM_NCACTIVATE
			STATIC hWndSaveFocus AS DWORD
			IF ISFALSE CB.WPARAM THEN ' Save control focus
				hWndSaveFocus = GetFocus()
			ELSEIF hWndSaveFocus THEN ' Restore control focus
				SetFocus(hWndSaveFocus)
				hWndSaveFocus = 0
			END IF
		CASE %WM_COMMAND            ' Process control notifications
			SELECT CASE AS LONG CB.CTL
				CASE %IDCLOSE
					IF CB.CTLMSG = %BN_CLICKED OR CB.CTLMSG = 1 THEN
						DIALOG END CB.HNDL
					END IF
			END SELECT
	END SELECT
END FUNCTION
'------------------------------------------------------------------------------
